﻿using System.Collections.Generic;
using System.Linq;
using Sixeyed.Caching.Containers.Interception.Cache;
using Sixeyed.Caching;
using LinqToCache;

namespace DAL
{
    public class CategoryDomainModel
    {
        private ProductsContext db = new ProductsContext();

        public IEnumerable<Category> GetAllCategoriesNoCache()
        {
            return GetAllCategories().ToList();
        }

        public IEnumerable<Category> GetAllCategoriesManualCache()
        {
            var categories = Cache.Memory.Get<List<Category>>("GetAllCategories");
            if (categories == null)
            {
                categories = GetAllCategories().ToList();
                Cache.Memory.Set("GetAllCategories", categories);
            }
            return categories;
        }

        [Cache(CacheType.Memory)]
        public virtual IEnumerable<Category> GetAllCategoriesAOPCache()
        {
            return GetAllCategories().ToList();
        }

        public IEnumerable<Category> GetAllUsersSQLDependencyCache()
        {
            return GetAllCategories().AsCached().ToList();
        }

        protected IQueryable<Category> GetAllCategories()
        {
            return db.Categories.AsQueryable();
        }
    }
}
